#!/usr/bin/env python
#
# {{cookiecutter.package_name}} documentation build configuration file, created by
# cookiecutter
#
# This file is execfile()d with the current directory set to its
# containing dir.
#
# Note that not all possible configuration values are present in this
# autogenerated file.
#
# All configuration values have a default; values that are commented out
# serve to show the default.
# If extensions (or modules to document with autodoc) are in another
# directory, add these directories to sys.path here. If the directory is
# relative to the documentation root, use os.path.abspath to make it
# absolute, like shown here.
#
import os
import re
import sys

sys.path.insert(0, os.path.abspath(".."))

project_title = "{{cookiecutter.package_name}}".replace("_", " ").title()

html_logo = "images/logo.svg"
latex_logo = "images/logo.pdf"

# -- General configuration ---------------------------------------------

# If your documentation needs a minimal Sphinx version, state it here.
#
# needs_sphinx = '1.0'

# Attempt to make links automatially
default_role = "code"

# Add any Sphinx extension module names here, as strings. They can be
# extensions coming with Sphinx (named 'sphinx.ext.*') or your custom ones.
# CFAB added:
#   napolean to support google-style docstrings
#   autodoc for generating api docs
#   rsvgconverter for converting svg images
#   intersphinx for documenting other projects' code
extensions = [
    "sphinx.ext.viewcode",
    "sphinx.ext.napoleon",  # For supporting Google-style docstrings
    "sphinx.ext.autodoc",  # For automatically documenting the APIs of python code
    # "sphinxcontrib.rsvgconverter",  # For converting svg images for the pdf generation
    "sphinx.ext.intersphinx",  # For linking to docs in other projects
    "sphinx.ext.autosectionlabel",  # For automatically labelling sections, for internal references
]

# If you'd like to be able to link to other project's code, put a link to their
# sphinx-generated docs here
intersphinx_mapping = {
    "python": ("https://docs.python.org/3", None),
}

# Add any paths that contain templates here, relative to this directory.
templates_path = ["_templates"]

# The suffix(es) of source filenames.
# You can specify multiple suffix as a list of string:
#
# source_suffix = ['.rst', '.md']
source_suffix = ".rst"

# The master toctree document.
master_doc = "index"

# General information about the project.
project = project_title
copyright = "{{cookiecutter.author_name}}"
author = "{{cookiecutter.author_name}}"

# %% Detecting code version


def tex_escape(text):
    """
    A function for escaping a string to be displayed in Latex

    :param text: a plain text message
    :return: the message escaped to appear correctly in LaTeX
    """
    conv = {
        "&": r"\&",
        "%": r"\%",
        "$": r"\$",
        "#": r"\#",
        "_": r"\_",
        "{": r"\{",
        "}": r"\}",
        "~": r"\textasciitilde{}",
        "^": r"\^{}",
        "\\": r"\textbackslash{}",
        "<": r"\textless{}",
        ">": r"\textgreater{}",
    }
    regex = re.compile(
        "|".join(
            re.escape(str(key))
            for key in sorted(conv.keys(), key=lambda item: -len(item))
        )
    )
    return regex.sub(lambda match: conv[match.group()], text)


# %% Version description

# If running on Gitlab's CI, get the version from the environmental variables.
# Note that this isn't a built in variable, it's one I've added in another CI
# job.
if "GIT_DESCRIBE" in os.environ:
    version = os.environ["GIT_DESCRIBE"]
# Else, attempt to get it from the package
else:
    import {{cookiecutter.package_name}}

    version = {{cookiecutter.package_name}}.__version__

# If we're building for latex, escape the string
if "latex" in sys.argv:
    print("Latex detected")
    version = tex_escape(version)
    print(f"Using version = '{version}'")

# The full version, including alpha/beta/rc tags.
release = version

# The language for content autogenerated by Sphinx. Refer to documentation
# for a list of supported languages.
#
# This is also used if you do content translation via gettext catalogs.
# Usually you set "language" from the command line for these cases.
language = None

# List of patterns, relative to source directory, that match files and
# directories to ignore when looking for source files.
# This patterns also effect to html_static_path and html_extra_path
exclude_patterns = ["_build", "Thumbs.db", ".DS_Store"]

# The name of the Pygments (syntax highlighting) style to use.
pygments_style = "sphinx"

# If true, `todo` and `todoList` produce output, else they produce nothing.
todo_include_todos = False


# -- Options for HTML output -------------------------------------------

# The theme to use for HTML and HTML Help pages.  See the documentation for
# a list of builtin themes.
#
html_theme = "sphinx_rtd_theme"

# Theme options are theme-specific and customize the look and feel of a
# theme further.  For a list of options available for each theme, see the
# documentation.
#
# html_theme_options = {}

# Add any paths that contain custom static files (such as style sheets) here,
# relative to this directory. They are copied after the builtin static files,
# so a file named "default.css" will overwrite the builtin "default.css".
html_static_path = ["_static"]


# -- Options for HTMLHelp output ---------------------------------------

# Output file base name for HTML help builder.
htmlhelp_basename = "{{cookiecutter.package_name}}doc"


# -- Options for LaTeX output ------------------------------------------

latex_elements = {
    # The paper size ('letterpaper' or 'a4paper').
    #
    # 'papersize': 'letterpaper',
    # The font size ('10pt', '11pt' or '12pt').
    #
    # 'pointsize': '10pt',
    # Additional stuff for the LaTeX preamble.
    #
    # 'preamble': '',
    # Latex figure (float) alignment
    #
    # 'figure_align': 'htbp',
}

# Grouping the document tree into LaTeX files. List of tuples
# (source start file, target name, title, author, documentclass
# [howto, manual, or own class]).
latex_documents = [
    (
        master_doc,
        "{{cookiecutter.package_name}}.tex",
        "{} Documentation".format(project_title),
        "{{cookiecutter.author_name}}",
        "manual",
    ),
]


# -- Options for manual page output ------------------------------------

# One entry per manual page. List of tuples
# (source start file, name, description, authors, manual section).
man_pages = [
    (
        master_doc,
        "{{cookiecutter.package_name}}",
        "{{cookiecutter.package_name}} Documentation",
        [author],
        1,
    )
]


# -- Options for Texinfo output ----------------------------------------

# Grouping the document tree into Texinfo files. List of tuples
# (source start file, target name, title, author,
#  dir menu entry, description, category)
texinfo_documents = [
    (
        master_doc,
        "{{cookiecutter.package_name}}",
        "{{cookiecutter.package_name}} Documentation",
        author,
        "{{cookiecutter.package_name}}",
        "A simple Python package, with support for tests by pytest, linting by black and pre-commit, all preconfigured for gitlab CI. ",
        "Miscellaneous",
    ),
]
